﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.Core;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.CEDMA.Core {
  public partial class ResultsViewContainer : ViewBase {
    private Results results;

    public ResultsViewContainer(Results results) {
      this.results = results;
      InitializeComponent();
      PopulateViewComboBox();
      showButton.Enabled = false;
    }

    private void PopulateViewComboBox() {
      DiscoveryService service = new DiscoveryService();
      Type[] viewTypes = service.GetTypes(typeof(IResultsView));
      foreach (Type t in viewTypes)
        viewComboBox.Items.Add(t);
    }

    private void showButton_Click(object sender, EventArgs e) {
      viewPanel.Controls.Clear();
      try {
        Type type = (Type)viewComboBox.SelectedItem;
        IResultsView view = (IResultsView)Activator.CreateInstance(type);
        Control control = view.Control;
        viewPanel.Controls.Add(control);
        control.Dock = DockStyle.Fill;
        view.ShowResults(results);
      }
      catch (Exception ex) {
        Label errorLabel = new Label();
        errorLabel.Text = "Couldn't load selected view: " + viewComboBox.SelectedItem + "\n" + ex.Message;
        viewPanel.Controls.Add(errorLabel);
        errorLabel.Dock = DockStyle.Fill;
      }
    }

    private void viewComboBox_SelectedValueChanged(object sender, EventArgs e) {
      showButton.Enabled = viewComboBox.SelectedItem != null;
    }
  }
}
