﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HeuristicLab.Core;
using HeuristicLab.CEDMA.Core;

namespace HeuristicLab.CEDMA.Core {
  public partial class TableResultsView : ViewBase, IResultsView {
    private Results results;
    public TableResultsView() {
      InitializeComponent();
    }

    public Control Control {
      get { return this; }
    }

    public void ShowResults(Results results) {
      this.results = results;
      UpdateControls();
    }

    protected override void UpdateControls() {
      base.UpdateControls();
      if (results == null) return;
      List<string> columnNames = new List<string>();
      columnNames.AddRange(Results.CategoricalVariables);
      columnNames.AddRange(Results.OrdinalVariables);
      dataGridView.Rows.Clear();
      dataGridView.Columns.Clear();
      foreach (string varName in columnNames) {
        dataGridView.Columns.Add(varName, varName);
      }

      foreach (object[] row in results.SelectRows(columnNames)) {
        dataGridView.Rows.Add(row);
      }
      dataGridView.Update();
    }
  }
}
